/*
 * Common structures and functions.
 *
 * Copyright (C) 2022, 2023, 2024 Paul Boddie <paul@boddie.org.uk>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA  02110-1301, USA
 */

#pragma once

#include <l4/re/l4aux.h>

#include <systypes/base.h>



EXTERN_C_BEGIN

/* Common definitions. */

#define ENV_INTERNAL_PAGER_NAME "intpager"
#define MEM_INTERNAL_PAGER_LIMIT (10 * L4_PAGESIZE)



/* Auxiliary vector key-value pair. */

struct auxv_entry
{
  l4_umword_t key, value;
};

/* Region description. */

struct exec_region
{
  l4_addr_t start;
  offset_t size;
  l4_umword_t flags;
  l4_cap_idx_t ds;
};



/* Utility functions. */

l4re_aux_t *exec_get_l4re_aux(int argc, char *argv[]);

EXTERN_C_END

/* vim: tabstop=2 expandtab shiftwidth=2
*/
